.Dd 2016-12-30
.Dt CLAV-MUTATION-FIND 1
.Os
.Sh NAME
.Nm clav-mutation-find
.Nd Find a sequence of mutations transforming one quiver to another.
.Sh SYNOPSIS
.Nm
.Fl s
.Ar start-file
.Fl e
.Ar end-file
.Oo
.Fl R
.Oc
.Oo
.Fl H
.Oc
.Oo
.Fl c
.Ar edge-cap
.Oc
.Oo
.Fl l
.Ar start-mutation-len
.Oc
.Oo
.Fl m
.Ar max-mutation-len
.Oc
.Oo
.Fl f
.Ar frozen-vertex
.Oo
.Fl f
.Ar frozen-vertex
.Oo ...
.Oc
.Oc
.Oc
.Sh DESCRIPTION
.Nm
loads two quivers from
.Ar start-file
and
.Ar end-file .
If they have the same number of vertices,
.Nm
will attempt to find all sequences of nontrivial mutations which will transform
.Ar start-file
into
.Ar end-file .
.Pp
Progress is printed
.Po although, due to optimizations used, it is not a good estimator of
completion time
.Pc regularly,
and immediate status is available by sending
.Ar SIGUSR1
to the process
.Pq see Sx BUGS .
.Pp
The search is exhaustive up to interchanging mutations which commute
.Po and up to edge-cap, see
.Sx BUGS
.Pc
and single-threaded, though some care has been taken to make it
efficient. Some known checks, such as trivial connectedness, are not
performed.
.Sh OPTIONS
.Bl -tag -width Ds
.It Fl s
The
.Ar start-file
as written by
.Xr clav-sdl 1
or
.Xr clav-cli 1 .
.It Fl e
The
.Ar end-file
as written by
.Xr clav-sdl 1
or
.Xr clav-cli 1 .
The vertices of
.Ar start-file
and
.Ar end-file
must match.
.It Fl c
Set the
.Ar edge-cap ,
as described in
.Sx BUGS .
If unspecified,
.Fa 1 + F
is used, where
.Fa F
is the maximum fatness of a vertex in
.Ar start-file .
.It Fl R
If set, require all non-frozen vertices to participate in the
mutation. This is useful for trying to find flips.
.It Fl H
If set, use a heuristic check (in not ε, not σ) rather than a
strict graph equality for checking whether a mutation sequence is
acceptable.  This is useful for trying to find flips, in which the
general shape of the desired end graph is known, but it is not known
which labels in the start file correspond to which labels in the
end file.
.It Fl f
Mark a vertex
.Pq by name
as
.Sq frozen .
Frozen vertices are not considered for mutation.  If you know which
vertices are frozen, this can greatly speed up the search.
.It Fl l
Start searching with mutations at length
.Ar start-mutation-length .
If unspecified,
.Ar 0
is used.
.It Fl m
Set the maximum mutation length. If unspecified, the program will perform
a search bounded by
.Fa (size_t) -1
, which
.Pq depending on hardware
may take multiple universe-lifespans to complete.
.El
.Sh EXAMPLES
.Dl % clav-mutation-find -s "data/C2_U02_C2.txt" -e "data/μ(C2_U02_C2).txt" -f 01 -f 10 -f 12 -f 21 -f 23 -f 32 -f 30 -f 03 -l 7 -m 9
.Dl Exhausted length 7
.Dl Exhausted length 8
.Dl SEQUENCE: \& \& \& \& 0, ∞, 1, 2, 1*, 1, 2*, 0, 1*
.Dl SEQUENCE: \& \& \& \& 0, ∞, 1, 2, 1*, 2*, 0, 1, 1*
.Dl Exhausted length 9
.Dl \&
.Dl % clav-mutation-find -s "data/C2_U02_C2.txt" -e "data/μ(C2_U02_C2).txt" -f 01 -f 10 -f 12 -f 21 -f 23 -f 32 -f 30 -f 03 -l 7 -m 9 -H -R
.Dl Exhausted length 7
.Dl Exhausted length 8
.Dl SEQUENCE:  \& \& \& \& 0, ∞, 1, 2, 1*, 1, 2*, 0, 1*
.Dl SEQUENCE:  \& \& \& \& 0, ∞, 1, 2, 1*, 2*, 0, 1, 1*
.Dl SEQUENCE:  \& \& \& \& 0, ∞, 2, 0, ∞, 2, 1, 2*, 1*
.Dl SEQUENCE:  \& \& \& \& 0, ∞, 2*, 0, ∞, 1*, 2*, 2, 1
.Dl SEQUENCE:  \& \& \& \& 0, ∞, 2*, 0, ∞, 2*, 2, 1, 1*
.Dl SEQUENCE:  \& \& \& \& ∞, 2, 0, ∞, 2*, 0, 1*, 2*, 1
.Dl SEQUENCE:  \& \& \& \& ∞, 2, 0, ∞, 2*, 0, 2*, 1, 1*
.Dl SEQUENCE:  \& \& \& \& ∞, 2, 0, 2*, 0, ∞, 1*, 2*, 1
.Dl SEQUENCE:  \& \& \& \& ∞, 2, 0, 2*, 0, ∞, 2*, 1, 1*
.Dl SEQUENCE:  \& \& \& \& ∞, 2*, 0, ∞, 2, 0, 2, 1, 1*
.Dl SEQUENCE:  \& \& \& \& ∞, 2*, 0, 2, 0, ∞, 2, 1, 1*
.Dl SEQUENCE:  \& \& \& \& 2, 0, ∞, 2*, 0, ∞, 1*, 2*, 1
.Dl SEQUENCE:  \& \& \& \& 2, 0, ∞, 2*, 0, ∞, 2*, 1, 1*
.Dl SEQUENCE:  \& \& \& \& 2, 1, ∞, 0, 2*, 0, 2*, ∞, 1*
.Dl SEQUENCE:  \& \& \& \& 2, 1, 2*, 0, ∞, 1*, ∞, 1*, 0
.Dl SEQUENCE:  \& \& \& \& 2*, 0, ∞, 2, 0, ∞, 2, 1, 1*
.Dl SEQUENCE:  \& \& \& \& 2*, 0, 1*, ∞, 2, 0, ∞, 2, 1
.Dl Exhausted length 9
.Sh SEE ALSO
.Xr clav-sdl 1
.Xr clav-cli 1
.Sh BUGS
In general, mutations in quivers may cause edge weights εᵢⱼ to become
arbitrarily high. In general, mutations which cause edge weights to become
large are not interesting, therefore a rather naive implementation of
rational numbers is used for quiver edges. In order to protect this
implementation from overflow errors
.Po and to prevent the search from wasting time in uninteresting
implementations
.Pc
the finder will prune a sequence of mutations if it yields an edge with
any |εᵢⱼ| higher than
.Ar edge-cap .
.Pp
Sending
.Ar SIGUSR1
to
.Nm
will cause the current status to be printed.  For portability concerns,
even if your system supports
.Ar SIGINFO ,
that signal will not cause the same effect. Patches welcome.
.Sh AUTHORS
.An S. Gilles Aq Mt sgilles@math.umd.edu
